def remove_duplicates(nested_list):
    unique_list = []  # Пустой список
    for element in nested_list:
        if element not in unique_list:  # Проверяем каждый элемент
            unique_list.append(element)  # Добавляем, если элемент уникален
    return unique_list

def to_line(arr: list):
   out = []
   for i in arr:
       if isinstance(i, list):
            tl_arr = to_line(i)
            for j in tl_arr:
                out.append(j)
       else:
           out.append(i)

   return out

def storagesDefendsByDefenderFind(startPos, endurance, exceptions):
    storages = []

    exceptions.append(startPos)
    for i in range(len(storagesPathes[startPos])):
        if storagesPathes[startPos][i] in exceptions:
            continue

        storages.append(storagesPathes[startPos][i])

        if endurance > 1:
            storages.append(storagesDefendsByDefenderFind(storagesPathes[startPos][i], endurance - 1, exceptions))
        else:
            exceptions.append(storagesPathes[startPos][i])

    return to_line(storages)

def readValues():
    s = input()

    length = len(s)
    integers = []
    i = 0

    while i < length:
        s_int = ''
        while i < length and '0' <= s[i] <= '9':
            s_int += s[i]
            i += 1
        i += 1
        if s_int != '':
            integers.append(int(s_int))

    return integers

#Work
NMK = readValues()

storagesPathes = []

for i in range(NMK[0]):
    storagesPathes.append([])

for i in range(NMK[1]):
    path = readValues()
    storagesPathes[path[0] - 1].append(path[1] - 1)
    storagesPathes[path[1] - 1].append(path[0] - 1)

storagesDefendes = []

for i in range(NMK[2]):
    defender = readValues()
    storagesDefendes.append(storagesDefendsByDefenderFind(defender[0] - 1, defender[1], storagesDefendes))
    storagesDefendes.append(defender[0] - 1)
    storagesDefendes = to_line(storagesDefendes)

storagesDefendes = sorted(remove_duplicates(storagesDefendes))

for i in range(len(storagesDefendes)):
    storagesDefendes[i] += 1

print(len(storagesDefendes))
print(' '.join(map(str, storagesDefendes)))

